'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 *
 */
var Context = function () {

  /**
   * Create a new {Context} instance.
   */
  function Context() {
    _classCallCheck(this, Context);

    this._c = {};
  }

  /**
   * Retrieve the entire context.
   *
   * @returns {object}
   */


  _createClass(Context, [{
    key: 'all',
    value: function all() {
      return _lodash2.default.clone(this._c);
    }

    /**
     * Set the value of a particular context.
     *
     * @param {object} item
     */

  }, {
    key: 'set',
    value: function set(key, value) {
      if (!key || !value) {
        throw new Error('The context must accept a key/value pair');
      }

      this._c[key] = value;
    }

    /**
     * Remove a particular value from the context.
     *
     * @param {string} key
     */

  }, {
    key: 'unset',
    value: function unset(key) {
      delete this._c[key];
    }

    /**
     * Retrieve a value from the context.
     *
     * @param {string} key
     * @returns {} value
     */

  }, {
    key: 'get',
    value: function get(key) {
      return this._c[key];
    }

    /**
     * Check if a particular context exists.
     *
     * @param {string} key
     * @returns {boolean}
     */

  }, {
    key: 'has',
    value: function has(key) {
      var v = this.get(key);
      return v !== undefined && v !== null;
    }
  }]);

  return Context;
}();

exports.default = Context;
module.exports = exports['default'];