'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _errorCode = require('../error-code');

var _errorCode2 = _interopRequireDefault(_errorCode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseError = function (_Error) {
  _inherits(BaseError, _Error);

  /**
   * Create a base error
   *
   * @returns {Object} error
   */
  function BaseError() {
    _classCallCheck(this, BaseError);

    var _this = _possibleConstructorReturn(this, (BaseError.__proto__ || Object.getPrototypeOf(BaseError)).call(this));

    _this.type = BaseError.getType();
    _this.status = 0;
    _this.message = _get(BaseError.prototype.__proto__ || Object.getPrototypeOf(BaseError.prototype), 'message', _this);
    _this.context = [];

    /**
     * Add some context to the error.
     *
     * @param {Object} e
     */
    _this.push = function (e) {
      if (e instanceof _errorCode2.default) {
        var hasCodeAlready = false;
        for (var i = 0; i < this.context; i++) {
          if (this.context[i].code === e.code) {
            debug('The specified error code has already been supplied');
            debug(e);
            return this;
          }
        }
        this.context.push(e);
      } else {
        throw new Error('You may only pass through {ErrorCode} instances to the error context');
      }
      return this;
    };
    return _this;
  }

  /**
   * Retrieve the type of the error.
   *
   * @returns {string}
   */


  _createClass(BaseError, null, [{
    key: 'getType',
    value: function getType() {
      return 'BaseError';
    }
  }]);

  return BaseError;
}(Error);

exports.default = BaseError;
module.exports = exports['default'];