'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Utilities = function () {
  function Utilities() {
    _classCallCheck(this, Utilities);
  }

  _createClass(Utilities, null, [{
    key: 'ensureDirSync',


    /**
     * Ensure the directory is created.
     *
     * @param {string} dirPath
     */
    value: function ensureDirSync(dirPath) {
      if (!_fs2.default.existsSync(dirPath)) {
        _fsExtra2.default.ensureDirSync(dirPath);
      } else {
        if (!_fs2.default.lstatSync(dirPath).isDirectory()) {
          throw new Error('Unable to create a directory at [' + dirPath + '] because a file with the name [' + _path2.default.parse(dirPath).base + '] already exists');
        }
      }
    }

    /**
     * Check if the specified file is already
     * published to the specified directory.
     *
     * @param {string} fileName
     * @param {string} dirPath
     * @returns {boolean}
     */

  }, {
    key: 'isFilePublished',
    value: function isFilePublished(fileName, dirPath) {
      var filePath = _path2.default.join(dirPath, fileName);

      if (_fs2.default.existsSync(filePath) && _fs2.default.lstatSync(filePath).isFile()) {
        return true;
      } else {
        return false;
      }
    }

    /**
     * Publish the specified file with the specified name
     * into the specified directory.
     *
     * @param {string} filePath
     * @param {string} dirPath
     */

  }, {
    key: 'publishFile',
    value: function publishFile(filePath, dirPath) {
      var fileName = _path2.default.parse(filePath).base;

      if (!Utilities.isFilePublished(fileName, dirPath)) {
        if (!_fs2.default.lstatSync(filePath).isDirectory()) {
          _fsExtra2.default.copySync(filePath, _path2.default.join(dirPath, fileName));
        }
      }
    }
  }]);

  return Utilities;
}();

exports.default = Utilities;
module.exports = exports['default'];