'use strict';

import BaseError from './base-error';

export default class BadRequestError extends BaseError {

  /**
   * Create a BadRequestError response
   *
   * @returns {Object} error
   */
  constructor() {
    super();
    this.type = BadRequestError.getType();
    this.status = 400;
    this.message = 'The server could not process the request'
  }

  /**
   * Retrieve the type of the error.
   *
   * @returns {string}
   */
  static getType() {
    return 'BadRequestError';
  }

}
