'use strict';

import BaseError from './base-error';

export default class NotFoundError extends BaseError {

  /**
   * Create a NotFoundError response
   *
   * @returns {Object} error
   */
  constructor() {
    super();
    this.type = NotFoundError.getType();
    this.status = 404;
    this.message = 'The intended resource could not be found';
  }

  /**
   * Retrieve the type of the error.
   *
   * @returns {string}
   */
  static getType() {
    return 'NotFoundError';
  }

}
