'use strict';

import BaseError from './base-error';

export default class UnauthorizedError extends BaseError {

  /**
   * Create a UnauthorizedError response
   *
   * @returns {Object} error
   */
  constructor() {
    super();
    this.type = UnauthorizedError.getType();
    this.status = 401;
    this.message = 'You are unauthorized to make that request';
  }

  /**
   * Retrieve the type of the error.
   *
   * @returns {string}
   */
  static getType() {
    return 'UnauthorizedError';
  }

}
